# Generic Makefile for one or more self-contained scripts (awk, bask, etc.)
# Last edited on 2010-03-06 20:00:11 by stolfilocal

######################################################################
# To be included by the top-level Makefile in the program's directory.
# The caller must define 
#   ${PROG} or ${PROGS} (user-executable scripts)

ifeq "/${PROGS}" "/"
PROGS := ${PROG}
endif

ifeq "/${LIBS}" "/"
LIBS := ${LIB}
endif

ifneq "/${PROGS}${LIBS}" "/"

SHELL := /bin/sh

# Make targets:
.PHONY:: \
  all actions \
  build build-progs build-libs check \
  clean

all: build

#---------------------------------------------------------------------
# "make actions" performs the actions listed in ${ACTIONS}, if any
actions:
ifeq "/${ACTIONS}" "/"
	@echo '$${ACTIONS} is empty'
else
	${MAKE} ${ACTIONS}
endif

#---------------------------------------------------------------------
# "make build" does nothing:

build: ${PROGS} ${LIBS}
  
#---------------------------------------------------------------------
# "make check" runs the tests in the "tests" subdirectory.

TEST_DIR := tests

check: ${PROG}
	( cd ${TEST_DIR} && ${MAKE} all )

#---------------------------------------------------------------------
# "make clean" deletes all derived files.

clean:
	-/bin/rm -f core 
	( cd ${TEST_DIR} && ${MAKE} clean )

endif
# End of ${PROGS}/${LIBS} section.
######################################################################

