#ifndef pst_weight_map_H
#define pst_weight_map_H

/* pst_weight_map.h -- procedures for working with pixel weight maps. */
/* Last edited on 2008-11-10 19:01:54 by stolfi */

#include <bool.h>

#include <float_image.h>

/* WEIGHT MAPS
  
  A /weight map/ is a float-valued image {IW} where
  each element {IW[c,x,y]} is a non-negative weight. 
*/

float_image_t *pst_weight_map_shrink(float_image_t *ID, bool_t harmonicZ);
  /* Given a weight map {IW} for some image {IM}, returns another
    weight map {JW} appropriate for a half-sized version {JM} of the
    image.
    
    Each weight in the reduced map is an average of four weights of
    the given map. The average is the arithmetic mean if {harmonic} is
    false, of the harmonic mean if {harmonic} is true.
    
    If the width of {IW} is odd, the last column is implicitly doubled
    before the image is shrunk. Ditto for the last row, if the height
    is odd. */

#endif
